-- Test invoice_product_tax
set client_min_messages to warning;
create extension if not exists pgtap;
reset client_min_messages;

begin;

select plan(27);

set search_path to camper, auth, public;

select has_table('invoice_product_tax');
select has_pk('invoice_product_tax' );
select col_is_pk('invoice_product_tax', array['invoice_product_id', 'tax_id']);
select table_privs_are('invoice_product_tax', 'guest', array []::text[]);
select table_privs_are('invoice_product_tax', 'employee', array ['SELECT', 'INSERT', 'UPDATE', 'DELETE']);
select table_privs_are('invoice_product_tax', 'admin', array ['SELECT', 'INSERT', 'UPDATE', 'DELETE']);
select table_privs_are('invoice_product_tax', 'authenticator', array []::text[]);

select has_column('invoice_product_tax', 'invoice_product_id');
select col_is_fk('invoice_product_tax', 'invoice_product_id');
select fk_ok('invoice_product_tax', 'invoice_product_id', 'invoice_product', 'invoice_product_id');
select col_type_is('invoice_product_tax', 'invoice_product_id', 'integer');
select col_not_null('invoice_product_tax', 'invoice_product_id');
select col_hasnt_default('invoice_product_tax', 'invoice_product_id');

select has_column('invoice_product_tax', 'tax_id');
select col_is_fk('invoice_product_tax', 'tax_id');
select fk_ok('invoice_product_tax', 'tax_id', 'tax', 'tax_id');
select col_type_is('invoice_product_tax', 'tax_id', 'integer');
select col_not_null('invoice_product_tax', 'tax_id');
select col_hasnt_default('invoice_product_tax', 'tax_id');

select has_column('invoice_product_tax', 'tax_rate');
select col_type_is('invoice_product_tax', 'tax_rate', 'tax_rate');
select col_not_null('invoice_product_tax', 'tax_rate');
select col_hasnt_default('invoice_product_tax', 'tax_rate');


set client_min_messages to warning;
truncate invoice_product_tax cascade;
truncate invoice_product cascade;
truncate invoice cascade;
truncate tax cascade;
truncate tax_class cascade;
truncate contact cascade;
truncate company_host cascade;
truncate company_user cascade;
truncate payment_method cascade;
truncate company cascade;
truncate auth."user" cascade;
reset client_min_messages;

insert into auth."user" (user_id, email, name, password, cookie, cookie_expires_at)
values (1, 'demo@tandem.blog', 'Demo', 'test', '44facbb30d8a419dfd4bfbc44a4b5539d4970148dfc84bed0e', current_timestamp + interval '1 month')
     , (5, 'admin@tandem.blog', 'Demo', 'test', '12af4c88b528c2ad4222e3740496ecbc58e76e26f087657524', current_timestamp + interval '1 month')
;

insert into company (company_id, business_name, vatin, trade_name, phone, email, web, address, city, province, postal_code, rtc_number, tourist_tax, tourist_tax_max_days, country_code, currency_code, default_lang_tag)
values (2, 'Company 2', 'XX123', '', '555-555-555', 'a@a', '', '', '', '', '', '', 60, 7, 'ES', 'EUR', 'ca')
     , (4, 'Company 4', 'XX234', '', '666-666-666', 'b@b', '', '', '', '', '', '', 60, 7, 'FR', 'USD', 'ca')
;

insert into company_user (company_id, user_id, role)
values (2, 1, 'admin')
     , (4, 5, 'admin')
;

insert into company_host (company_id, host)
values (2, 'co2')
     , (4, 'co4')
;

insert into payment_method (payment_method_id, company_id, name, instructions)
values (444, 4, 'cash', 'cash')
     , (222, 2, 'cash', 'cash')
;

insert into tax_class (tax_class_id, company_id, name)
values (22, 2, 'vat')
     , (44, 4, 'vat')
;

insert into tax (tax_id, company_id, tax_class_id, name, rate)
values (3, 2, 22, 'IVA 21 %', 0.21)
     , (6, 4, 44, 'IVA 10 %', 0.10)
;

insert into contact (contact_id, company_id, name, id_document_type_id, id_document_number, address, city, province, postal_code, country_code)
values ( 9, 2, 'Customer 1', 'D', '41440443Q', 'Fake St', 'City', 'Province', '17600', 'ES')
     , (10, 4, 'Customer 2', 'D', '41440443Q', 'Fake St', 'City', 'Province', '17600', 'ES')
;

insert into invoice (invoice_id, company_id, invoice_number, contact_id, currency_code, payment_method_id)
values (11, 2, 'INV001',  9, 'EUR', 222)
     , (12, 4, 'INV002', 10, 'EUR', 444)
;

insert into invoice_product (invoice_product_id, invoice_id, name, price)
values (13, 11, 'Product 1', 1200)
     , (14, 12, 'Product 2', 2400)
;

insert into invoice_product_tax (invoice_product_id, tax_id, tax_rate)
values (13, 3, 0.10)
     , (14, 6, -0.15)
;

prepare product_tax_data as
select invoice_product_id, tax_id
from invoice_product_tax
order by invoice_product_id, tax_id;

set role employee;
select is_empty('product_tax_data', 'Should show no data when cookie is not set yet');
reset role;

select set_cookie('44facbb30d8a419dfd4bfbc44a4b5539d4970148dfc84bed0e/demo@tandem.blog', 'co2');
select bag_eq(
	'product_tax_data',
	$$ values (13, 3)
	$$,
	'Should only list tax of products of the companies where demo@tandem.blog is user of'
);
reset role;

select set_cookie('12af4c88b528c2ad4222e3740496ecbc58e76e26f087657524/admin@tandem.blog', 'co4');
select bag_eq(
	'product_tax_data',
	$$ values (14, 6)
	$$,
	'Should only list tax of products of the companies where admin@tandem.blog is user of'
);
reset role;

select set_cookie('not-a-cookie', 'co4');
select throws_ok(
	'product_tax_data',
	'42501', 'permission denied for table invoice_product_tax',
	'Should not allow select to guest users'
);
reset role;


select *
from finish();

rollback;

